# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "FiniteSequenceAdapter",
    ]

from storm.zope.interfaces import IResultSet

from zope.component import adapts
from zope.interface import implements
from zope.interface.common.sequence import IFiniteSequence


class FiniteSequenceAdapter:

    adapts(IResultSet)
    implements(IFiniteSequence)

    def __init__(self, context):
        self.context = context

    def __getitem__(self, ix):
        return self.context[ix]

    def __iter__(self):
        return iter(self.context)

    def __len__(self):
        return self.context.count()
