# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "CountDistinct",
    ]

from storm.expr import (
    compile,
    EXPR,
    Expr,
    )


class CountDistinct(Expr):
    # storm's Count() implementation is broken for distinct with > 1
    # column.

    __slots__ = ("columns",)

    def __init__(self, columns):
        self.columns = columns


@compile.when(CountDistinct)
def compile_countdistinct(compile, countselect, state):
    state.push("context", EXPR)
    col = compile(countselect.columns)
    state.pop()
    return "count(distinct(%s))" % col
