# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "IDevice",
    "IDeviceSet",
    ]

from zope.interface import (
    Attribute,
    Interface,
    )

from lpresults.hardware.interfaces.devicecategory import IHasDeviceCategory
from lpresults.hardware.interfaces.deviceproduct import IHasDeviceProduct


class IDevice(IHasDeviceProduct, IHasDeviceCategory):

    product_id = Attribute("Device product identifier")
    vendor_id = Attribute("Device vendor identifier")
    parent = Attribute("Device parent")


class IDeviceSet(Interface):
    pass
