# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "IDeviceBus",
    "IHasDeviceBus",
    "IDeviceBusSet",
    ]

from zope.interface import (
    Attribute,
    Interface,
    )


class IDeviceBus(Interface):

    name = Attribute("Device bus name")


class IHasDeviceBus(Interface):

    bus = Attribute("Device bus")

    bus_name = Attribute("Device bus name")


class IDeviceBusSet(Interface):

    def get(id):
        """Return the device bus with the given id.

        If there's no device bus with the given id, return None.

        :param id: The primary id associated with a device bus.
        """

    def getByName(name):
        """Return the device bus with the given name.

        If there's no device bus with the given name, return None.

        :param name: The unique name associated with a device bus.
        """
