# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "IHasSystemUnit",
    "ISystemUnit",
    "ISystemUnitSet",
    ]

from zope.interface import (
    Attribute,
    Interface,
    )
from zope.schema import Object

from lazr.restful.declarations import exported
from lazr.restful.fields import Reference

from lpresults.hardware.interfaces.unit import (
    IUnit,
    IUnitSet,
    )


class ISystemUnit(IUnit):

    id = Attribute("A unique identifier for the system unit")

    system_id = Attribute("A unique identifier for the system")

    system = exported(
        Reference(
            title=u"System",
            schema=Interface,  # ISystem
            required=True))


class ISystemUnitSet(IUnitSet):
    """Interface representing the set of SystemUnits."""


class IHasSystemUnit(Interface):

    system_unit = Object(
        schema=ISystemUnit,
        title=u"System unit",
        required=True,
        readonly=True,
        description=u"System unit associated with this object.")
