# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "DeviceCategory",
    "device_category_set",
    ]

from storm.locals import (
    AutoReload,
    Int,
    Unicode,
    )

from zope.interface import implements

from lpresults.hardware.interfaces.devicecategory import (
    IDeviceCategory,
    IDeviceCategorySet,
    )
from lpresults.hardware.models.store import get_hardware_store


class DeviceCategory:

    __storm_table__ = "devicecategory"

    implements(IDeviceCategory)

    id = Int(primary=True, allow_none=False, default=AutoReload)
    name = Unicode(allow_none=False)

    def __init__(self, name):
        self.name = name


class DeviceCategorySet:

    implements(IDeviceCategorySet)

    def get(self, id):
        """See `IDeviceCategorySet`."""
        return get_hardware_store().get(DeviceCategory, id)

    def getByName(self, name):
        """See `IDeviceCategorySet`."""
        return get_hardware_store().execute(
            "SELECT get_device_category(?)", (name,)).get_one()[0]


device_category_set = DeviceCategorySet()
