# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "HardwarePciResult",
    ]

from zope.interface import implements

from lazr.delegates import delegates

from lpresults.repository.formats.pci import PciResult
from lpresults.repository.zope.interfaces import IResult

from lpresults.hardware.interfaces.date import IHasDateModified
from lpresults.hardware.models.devicebus import HasDeviceBusMixin


class HardwarePciResult(PciResult, HasDeviceBusMixin):

    implements(IResult)
    delegates(IHasDateModified, context="bus")

    bus_name = u"pci"

    def addVendor(self, vendor):
        self.bus.setVendor(vendor.name, vendor.id)

    def addDevice(self, device):
        self.bus.setProduct(device.name, device.id, device.vendor.id)

    def addSubdevice(self, subdevice):
        device = subdevice.device
        self.bus.setProduct(
            subdevice.name, device.id, device.vendor.id,
            subdevice.device_id, subdevice.vendor_id)
