# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "HardwarePnpResult",
    ]

from zope.interface import implements

from lazr.delegates import delegates

from lpresults.repository.formats.pnp import PnpResult
from lpresults.repository.zope.interfaces import IResult

from lpresults.hardware.interfaces.date import IHasDateModified
from lpresults.hardware.models.devicebus import HasDeviceBusMixin


class HardwarePnpResult(PnpResult, HasDeviceBusMixin):

    implements(IResult)
    delegates(IHasDateModified, context="bus")

    bus_name = u"pnp"

    def start(self):
        super(HardwarePnpResult, self).start()
        self.vendor_cache = set()

    def addVendor(self, vendor):
        if vendor.id not in self.vendor_cache:
            self.vendor_cache.add(vendor.id)
            self.bus.setVendor(vendor.name, vendor.id)

    def addDevice(self, device):
        self.bus.setProduct(device.name, device.id, device.vendor.id)
