# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "Processor",
    ]

from storm.locals import (
    AutoReload,
    Int,
    RawStr,
    Reference,
    Unicode,
    )

from zope.interface import implements

from lpresults.hardware.interfaces.processor import IProcessor
from lpresults.hardware.models.processorplatform import ProcessorPlatform


class Processor:

    __storm_table__ = "processor"

    implements(IProcessor)

    id = Int(primary=True, allow_none=False, default=AutoReload)
    platform_id = Int(allow_none=False)
    type = RawStr(allow_none=False)
    model = RawStr(allow_none=False)
    model_number = RawStr(allow_none=False)
    model_version = RawStr(allow_none=False)
    model_revision = RawStr(allow_none=False)
    cache = Int(allow_none=False)
    bogomips = Int(allow_none=False)
    speed = Int(allow_none=False)
    other = Unicode(allow_none=False)

    platform = Reference(platform_id, ProcessorPlatform.id)

    def __init__(self, platform, type, model, model_number, model_version,
            model_revision, cache, bogomips, speed, other):
        self.platform = platform
        self.type = type
        self.model = model
        self.model_number = model_number
        self.model_version = model_version
        self.model_revision = model_revision
        self.cache = cache
        self.bogomips = bogomips
        self.speed = speed
        self.other = other
