# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "TestFactory",
    ]

from zope.component import getUtility

from lpresults.database.store import get_store
from lpresults.database.testing import factories as database_factories

from lpresults.hardware.interfaces.system import ISystemSet


class DatabaseFactory(database_factories.DatabaseFactory):

    def getHardwareStore(self):
        return get_store("hardware")


class TestFactory(DatabaseFactory):

    def makeSystem(self, make=None, model=None):
        if make is None:
            make = self.getUniqueString(u"system-make")
        if model is None:
            model = self.getUniqueString(u"system-model")

        return getUtility(ISystemSet).retrieve(make, model)

    def makeSystemUnit(self, system=None, identifiers=None):
        if system is None:
            system = self.makeSystem()
        if identifiers is None:
            identifiers = [self.getUniqueString(u"unit-identifer")]

        return system.newUnit(identifiers)
