# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "IHasDateCreated",
    "IHasDateDeleted",
    "IHasDateModified",
    ]

from zope.interface import Interface
from zope.schema import Datetime


class IHasDateCreated(Interface):
    """Something created on a certain date."""

    date_created = Datetime(
        title=u"Date created",
        required=True,
        readonly=True)


class IHasDateDeleted(Interface):
    """Something deleted on a certain date."""

    date_deleted = Datetime(
        title=u"Date deleted",
        required=True,
        readonly=True)


class IHasDateModified(Interface):
    """Something modified on a certain date."""

    date_modified = Datetime(
        title=u"Date modified",
        required=True,
        readonly=True)
