# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ILaunchpad",
    ]

from zope.interface import Interface


class ILaunchpad(Interface):
    """Provide an interface for accessing Launchpad resources."""

    def proxy(request):
        """
        Proxy a request object to the Launchpad web root.

        Return the corresponding HTTP response.
        """

    def getPillar(pillar_name):
        """
        Return the Launchpad representation of a pillar if it exists.

        :param pillar_name: Name of the pillar.
        """

    def getPillarSeries(pillar_name, series_name):
        """
        Return the Launchpad representation of a series if it exists.

        :param pillar_name: Name of the pillar.
        :param series_name: Name of the series.
        """
