# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import defaultTestLoader

from zope.interface.verify import verifyObject

from lpresults.registry.interfaces.person import IHasPerson
from lpresults.registry.models.personhelper import PersonHelper
from lpresults.registry.testing.cases import TestCaseWithFactory
from lpresults.registry.testing.layers import FunctionalDatabaseLayer


class TestePersonHelper(TestCaseWithFactory):

    layer = FunctionalDatabaseLayer

    def test_hasPerson(self):
        helper = PersonHelper()
        self.assertTrue(verifyObject(IHasPerson, helper))

    def test_withPerson(self):
        person = self.factory.makePerson()
        helper = PersonHelper(person)
        self.assertEquals(helper.person, person)

    def test_withoutPerson(self):
        helper = PersonHelper()
        self.assertEquals(helper.person, None)


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
