# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "TestCase",
    "TestCaseWithFactory",
    ]

from lpresults.database.testing import cases as database_cases

from lpresults.registry.interfaces.launchpad import ILaunchpad
from lpresults.registry.testing.factories import TestFactory
from lpresults.registry.testing.fakes import FakeLaunchpad


class TestCase(database_cases.DatabaseTestCase):

    def setUp(self):
        super(TestCase, self).setUp()

        self.provideUtility(FakeLaunchpad(), ILaunchpad)


class TestCaseWithFactory(TestCase):

    factory_class = TestFactory

    def setUp(self):
        super(TestCaseWithFactory, self).setUp()

        self.factory = self.factory_class()
