# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import (
    defaultTestLoader,
    TestCase,
    )

from zope.schema.interfaces import ValidationError

from lpresults.registry.validators import (
    name_validator,
    valid_name,
    )


class TestNameValidator(TestCase):

    def test_valid(self):
        self.assertTrue(name_validator("he"))

    def test_invalid(self):
        self.assertRaises(ValidationError, name_validator, "h")


class TestValidName(TestCase):

    def test_lower(self):
        self.assertTrue(valid_name("hello"))

    def test_upper(self):
        self.assertFalse(valid_name("helLo"))

    def test_twoCharacters(self):
        self.assertTrue(valid_name("he"))

    def test_oneCharacter(self):
        self.assertFalse(valid_name("h"))


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
