# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

import settings

import martian

# Without this trickery, this module (called "django") will mask the
# real Django modules. We could use "from __future__ import
# absolute_import", but that would not work with Python 2.4.
ImproperlyConfigured = __import__(
    "django.core.exceptions", {}).core.exceptions.ImproperlyConfigured

from lpresults.repository.zope.zrepository import (
    ZRepository,
    global_zrepository,
    )


class DjangoZRepositoryGrokker(martian.ClassGrokker):
    """Pull repository source information from the Django 'settings'
    module.
    """
    martian.component(ZRepository)

    def execute(self, cls, config, *kw):
        if not hasattr(settings, "LPRESULTS_REPOSITORY_SOURCES"):
            raise ImproperlyConfigured(
                "You need to specify LPRESULTS_REPOSITORY_SOURCES"
                "in your Django settings file.")

        for name, url in settings.LPRESULTS_REPOSITORY_SOURCES.iteritems():
            global_zrepository.setDefaultURL(name, url)

        return True
