# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "Result",
    ]

import pytz

from datetime import datetime


UTC = pytz.timezone("UTC")


class Result:

    def __init__(self, source):
        self.source = source

    def start(self):
        """A result start command received."""
        self.date_modified = datetime.now(tz=UTC)

    def stop(self):
        """A result stop command received."""
        pass
