# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "FakeFactory",
    "FakeTimeoutCall",
    "FakeTransport",
    ]

from lpresults.repository.prober import ProberFactoryRedirect


class FakeFactory(ProberFactoryRedirect):

    redirectedTo = None

    def redirect(self, url):
        self.redirectedTo = url


class FakeTimeoutCall:

    resetCalled = False

    def reset(self, seconds):
        self.resetCalled = True


class FakeTransport:

    disconnecting = False

    def loseConnection(self):
        self.disconnecting = True

    def write(self, text):
        pass
