# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

import atexit
import doctest
import os

from pkg_resources import (
    cleanup_resources,
    resource_filename,
    )

import unittest

from zope.testing.cleanup import cleanUp


DOCTEST_FLAGS = (
    doctest.ELLIPSIS |
    doctest.NORMALIZE_WHITESPACE |
    doctest.REPORT_NDIFF)


def tearDown(test):
    """Run registered clean-up function."""
    cleanUp()


def test_suite():
    "Run the README.txt tests."
    doctest_files = [
        os.path.abspath(
            resource_filename("lpresults.repository", "README.txt")),
        ]
    kwargs = dict(
        module_relative=False,
        optionflags=DOCTEST_FLAGS,
        tearDown=tearDown)
    atexit.register(cleanup_resources)
    return unittest.TestSuite((
        doctest.DocFileSuite(*doctest_files, **kwargs)))
