# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from zope.component import getUtility
from zope.interface import Interface
from zope.schema import TextLine

from lpresults.repository.zope.interfaces import IZRepository


class IRepositoryDirective(Interface):

    name = TextLine(
        title=u"Name",
        description=u"Format name.")

    url = TextLine(
        title=u"URL",
        description=u"Repository URL.")


def add_repository_url(name, url):
    """Register C{url} as the default URL for repository called C{name}."""
    zrepository = getUtility(IZRepository)
    zrepository.setDefaultURL(name, url)


def repository(_context, name, url):
    _context.action(
        discriminator=("repository", name),
        callable=add_repository_url,
        args=(name, url))
