# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import defaultTestLoader

from lpresults.session.openid import (
    OpenIDStore,
    OpenIDAssociation,
    OpenIDNonce,
    )

from lpresults.session.tests.storetest import testStore

from lpresults.session.testing.cases import TestCaseWithFactory
from lpresults.session.testing.layers import DatabaseLayer


class TestOpenIDStore(TestCaseWithFactory):

    layer = DatabaseLayer

    def test_store(self):
        store = OpenIDStore(self.factory.getSessionStore())
        testStore(store)

    def test_association_unicode(self):
        """
        Unicode strings can be assigned to all the string attributes of
        OpenIDAssociation.
        """
        association = OpenIDAssociation(u"server URL", u"handle", u"secret",
                                       99, 100,
                                       u"association type")
        for attr in "server_url", "handle", "secret", "association_type":
            self.assertEquals(type(getattr(association, attr)), str)

    def test_nonce_unicode(self):
        """
        Unicode strings can be assigned to all the string attributes of
        OpenIDonce.
        """
        nonce = OpenIDNonce(u"server URL", 99, u"salt")
        for attr in "server_url", "salt":
            self.assertEquals(type(getattr(nonce, attr)), str)


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
