# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ClientError",
    "ServerError",
    "StorageError",
    ]


class StorageError(Exception):
    """Base class for errors trying to use storage."""


class ClientError(StorageError):
    """Error that can be recovered by the client."""


class ServerError(StorageError):
    """Error that cannot be recovered by the server."""
