# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import (
    defaultTestLoader,
    TestCase,
    )

from lpresults.storage.backend import Backend
from lpresults.storage.bucket import Bucket
from lpresults.storage.exceptions import ClientError


class TestBucket(TestCase):

    def test_backend(self):
        backend = Backend()
        bucket = Bucket(backend)
        self.assertEquals(bucket.getBackend(), backend)

    def test_getitem(self):
        bucket = Bucket(Backend())
        name = "foo"
        directory = bucket[name]
        self.assertEquals(directory.name, name)

    def test_invalidName(self):
        bucket = Bucket(Backend())
        name = "foo/bar"
        self.assertRaises(ClientError, bucket.__getitem__, name)


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
