# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

"""Validator functions."""

__metaclass__ = type

__all__ = [
    "valid_name",
    ]

import re


VALID_NAME_PATTERN = "[A-Za-z0-9][A-Za-z0-9\+\.\-]*"
VALID_NAME_RE = re.compile(r"^%s$" % VALID_NAME_PATTERN)


def valid_name(name):
    """Return True if the name is valid, otherwise False.

    :param name: The name attribute.
    """
    if VALID_NAME_RE.match(name):
        return True

    return False
