# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from zope.component import getUtility
from zope.interface import Interface
from zope.schema import TextLine

from lpresults.storage.zope.interfaces import IZStorage


class IStorageDirective(Interface):

    name = TextLine(
        title=u"Name",
        description=u"Storage name")

    uri = TextLine(
        title=u"URI",
        description=u"Backend URI")


def set_default_uri(name, uri):
    """Register C{uri} as the default URI for storage called C{name}."""
    zstorage = getUtility(IZStorage)
    zstorage.setDefaultURI(name, uri)


def storage(_context, name, uri):
    _context.action(
        discriminator=("storage", name),
        callable=set_default_uri,
        args=(name, uri))
