# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import (
    defaultTestLoader,
    TestCase,
    )

from zope.publisher.browser import TestRequest
from zope.security.management import (
    endInteraction,
    newInteraction,
    queryInteraction,
    )

from lpresults.storage.zope.utils import get_current_browser_request


class TestGetCurrentBrowserRequest(TestCase):

    def test_interaction(self):
        # When there is an interaction, it returns the interaction's request.
        request = TestRequest()
        newInteraction(request)
        self.assertEquals(request, get_current_browser_request())
        endInteraction()

    def test_no_interaction(self):
        self.assertEquals(None, queryInteraction())
        self.assertEquals(None, get_current_browser_request())


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
