# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "NotFoundView",
    ]


class StorageExceptionView:
    """Generic view handling exceptions on the storage."""

    def __init__(self, context, request):
        self.context = context
        self.request = request

    @property
    def status(self):
        """The HTTP status to use for the response."""
        raise NotImplementedError()

    def __call__(self):
        """Generate the HTTP response describing the exception."""
        response = self.request.response
        response.setStatus(self.status)
        response.setHeader("Content-Type", "text/plain")

        result = [self.context.__class__.__name__]

        return "".join(result)


class NotFoundView(StorageExceptionView):
    """View for NotFound."""

    status = 404
