# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "FakeRequest",
    "make_fake_request",
    ]

from zope.publisher.browser import TestRequest
from zope.security.management import (
    endInteraction,
    newInteraction,
    )


class FakeRequest(TestRequest):
    """Simple request object for testing purpose."""

    def __init__(self, method="GET", **kw):
        super(FakeRequest, self).__init__(REQUEST_METHOD=method, **kw)


def make_fake_request(**kw):
    """Return a fake request object with a new interaction."""
    request = FakeRequest(**kw)

    # After making the request, setup a new interaction.
    endInteraction()
    newInteraction(request)
    return request
