# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "FunctionalLayer",
    ]

import logging

from cStringIO import StringIO

from pkg_resources import resource_string

from zope.configuration import xmlconfig


class FunctionalLayerFactory:
    """Loads ZCML configuration for testing."""

    __bases__ = ()
    log = None
    zcml = "ftesting.zcml"

    def __init__(self, name, zcml=None):
        self.__name__ = name
        if zcml is not None:
            self.zcml = zcml

    def setUp(self):
        """Prepares layer for functional testing.
        """
        self.log = StringIO()
        # Make it silent but keep the log available for debugging
        logging.root.addHandler(logging.StreamHandler(self.log))

        if self.zcml is not None:
            package = ".".join(self.__module__.split(".")[:-2])
            string = resource_string(package, self.zcml)
            xmlconfig.string(string)

    def tearDown(self):
        """Tear down the whole layer."""

    def testSetUp(self):
        """Setup before a single test."""

    def testTearDown(self):
        """Tear down after a single test."""


FunctionalLayer = FunctionalLayerFactory("FunctionalLayer")
