# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "auth",
    "settings",
    "target",
    ]

from lpresults.registry.models.anonymous import Anonymous

from lpresults.tracker import settings as lpresults_settings


SETTINGS_CONTEXT = vars(lpresults_settings)


def auth(request):
    """
    Returns context variables required by apps that use Django's
    authentication system.
    """
    user = getattr(request, "user", Anonymous())
    return {
        "user": user,
        }


def settings(request):
    """
    Returns the settings so that they can be used by Django's
    templating system.
    """
    return SETTINGS_CONTEXT


def target(request):
    """
    Returns the target used in the application menu.
    """
    target = "/".join(request.path.split("/")[:2])

    return {
        "target": target,
        }
