# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "IFile",
    "IFileSet",
    ]

from zope.interface import (
    Attribute,
    Interface,
    )


class IFile(Interface):

    data = Attribute("The file content.")

    target = Attribute("Target which contains files.")


class IFileSet(Interface):

    def get(target, name):
        """Get a file by name from a target."""

    def put(target, name, data):
        """Put a file into the given target."""

    def list(target):
        """List the files in a particular target."""
