# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ITestDistroSeries",
    "ITestDistroSeriesSet",
    ]

from lazr.restful.declarations import export_as_webservice_entry

from lpresults.registry.interfaces.distroseries import (
    IDistroSeries,
    IDistroSeriesSet,
    )

from lpresults.tracker.interfaces.testcase import ITestCaseTarget
from lpresults.tracker.interfaces.testrank import ITestRankTarget
from lpresults.tracker.interfaces.testrun import ITestRunTarget
from lpresults.tracker.interfaces.teststat import ITestStatTarget
from lpresults.tracker.interfaces.testtarget import IHasTestTarget


class ITestDistroSeries(
    IDistroSeries, ITestCaseTarget, ITestRunTarget, ITestRankTarget,
    ITestStatTarget):
    """A test distribution series.

    This extends the concept of a distribution series with test information.
    """
    export_as_webservice_entry(singular_name="distro_series")


class ITestDistroSeriesSet(IDistroSeriesSet):
    """Interface representing the set of TestDistroSeries."""


IHasTestTarget["distro_series"].schema = ITestDistroSeries
