# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ITestProjectSeries",
    "ITestProjectSeriesSet",
    ]

from lazr.restful.declarations import export_as_webservice_entry

from lpresults.registry.interfaces.projectseries import (
    IProjectSeries,
    IProjectSeriesSet,
    )

from lpresults.tracker.interfaces.testcase import ITestCaseTarget
from lpresults.tracker.interfaces.testrank import ITestRankTarget
from lpresults.tracker.interfaces.testrun import ITestRunTarget
from lpresults.tracker.interfaces.teststat import ITestStatTarget
from lpresults.tracker.interfaces.testtarget import IHasTestTarget


class ITestProjectSeries(
    IProjectSeries, ITestCaseTarget, ITestRunTarget, ITestRankTarget,
    ITestStatTarget):
    """A test project series.

    This extends the concept of a project series with test information.
    """
    export_as_webservice_entry(singular_name="project_series")


class ITestProjectSeriesSet(IProjectSeriesSet):
    """Interface representing the set of TestProjectSeries."""


IHasTestTarget["project_series"].schema = ITestProjectSeries
