# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "TestSeriesSearchParams",
    ]

from lpresults.registry.interfaces.person import PersonParamsMixin
from lpresults.registry.interfaces.series import SeriesSearchParams

from lpresults.tracker.interfaces.testtarget import TestTargetParamsMixin


class TestSeriesSearchParams(
    SeriesSearchParams, PersonParamsMixin, TestTargetParamsMixin):
    """Encapsulates search parameters for ITestSeriesSet.search()"""

    def __init__(self, id=None, date_modified=None, **kwargs):
        super(TestSeriesSearchParams, self).__init__(**kwargs)
        self.id = id
        self.date_modified = date_modified
