# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "Command",
    ]

from openid.consumer.consumer import Consumer

from django.core.management.base import BaseCommand

from zope.testing import testrunner


class Command(BaseCommand):
    help = ("Runs the test suite for the specified applications, "
        "or the entire site if no args are specified.")
    args = "[testrunner args ...]"

    requires_model_validation = False

    def run_from_argv(self, argv):
        self.execute(*argv)

    def handle(self, *args):
        # Prevent any accidental OpenID authentications during the test run.
        Consumer.begin = lambda *a, **kw: 1 / 0

        # Run tests to call manage.py for subprocesses.
        defaults = [
            "--tests-pattern",
            "^f?tests$",
            "--test-path",
            "lib",
            ]
        script_parts = [
            "-S",
            args[0],
            args[1],
            ]
        args = list(args[1:])

        testrunner.run(defaults, args, script_parts=script_parts)
