# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ErrorMiddleware",
    ]

from django.http import HttpResponseForbidden

from lpresults.tracker.http import HttpResponseUnauthorized
from lpresults.tracker.views import (
    unauthorized,
    forbidden,
    )


class ErrorMiddleware:
    """Catches error responses and renders the appropriate template."""

    def process_response(self, request, response):
        if isinstance(response, HttpResponseUnauthorized):
            return unauthorized(request)

        elif isinstance(response, HttpResponseForbidden):
            return forbidden(request)

        else:
            return response
