# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import defaultTestLoader

from zope.component import getUtility

from lpresults.tracker.interfaces.testsystem import (
    ITestSystem,
    ITestSystemSet,
    )
from lpresults.tracker.models.tests.test_testrank import (
    TestHasTestRankSystemsMixin,
    )
from lpresults.tracker.testing.cases import TestCaseWithFactory
from lpresults.tracker.testing.layers import FunctionalDatabaseLayer


class TestTestSystem(TestCaseWithFactory):

    layer = FunctionalDatabaseLayer

    def test_init(self):
        test_system = self.factory.makeTestSystem()
        self.assertTrue(ITestSystem.providedBy(test_system))

    def test_cmp(self):
        test_system = self.factory.makeTestSystem()
        self.assertEquals(test_system, test_system)
        self.assertEquals(test_system, test_system.context)


class TestHasTestRankSystems(
    TestCaseWithFactory, TestHasTestRankSystemsMixin):

    def getContainer(self):
        return getUtility(ITestSystemSet)

    def getTestTarget(self):
        return self.factory.makeTestProject()


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
