# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "DownloadApplication",
    ]

from pkg_resources import resource_string

from zope.configuration import xmlconfig

from lpresults.storage.zope.wsgi import WSGIApplication

from lpresults.tracker import settings


class DownloadApplication(WSGIApplication):
    """Download End-Point."""

    @classmethod
    def configure_server(
        cls, config_package=settings.__package__,
        config_file="download.zcml"):
        """Configure server for a particular download service."""
        zcml = resource_string(config_package, config_file)
        xmlconfig.string(zcml)
