# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "RootApplication",
    ]

import logging.config

from os import environ

from pkg_resources import resource_string

from zope.configuration import xmlconfig

from django.core.handlers.wsgi import WSGIHandler

from lpresults.tracker import settings


class RootApplication:

    handler = WSGIHandler()

    def __init__(self, environ, start_response):
        self.response = self.handler(environ, start_response)

    def __iter__(self):
        return iter(self.response)

    @classmethod
    def configure_server(
        cls, config_package=settings.__package__, config_file="root.zcml"):
        """Configure server for a particular root application."""
        zcml = resource_string(config_package, config_file)
        xmlconfig.string(zcml)

        if settings.LPRESULTS_TRACKER_USE_HTTPS:
            environ["HTTPS"] = "on"
            environ["wsgi.url_scheme"] = "https"

        if settings.LPRESULTS_TRACKER_LOGGING:
            logging.config.fileConfig(settings.LPRESULTS_TRACKER_LOGGING)
