# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import (
    defaultTestLoader,
    TestCase,
    )

from zope.component import (
    getUtility,
    queryUtility,
    )
from zope.traversing.browser import absoluteURL

from lpresults.storage.zope.interfaces import (
    IStorageConfiguration,
    IStorageRootPage,
    )

from lpresults.tracker.services.storageservice import (
    StorageServiceConfiguration,
    StorageServiceRoot,
    )
from lpresults.tracker.testing.layers import FunctionalLayer


class TestStorageServiceConfiguration(TestCase):

    layer = FunctionalLayer

    def test_utility(self):
        utility = queryUtility(IStorageConfiguration)
        self.assertTrue(isinstance(utility, StorageServiceConfiguration))


class TestStorageServiceRoot(TestCase):

    layer = FunctionalLayer

    def test_utility(self):
        utility = queryUtility(IStorageRootPage)
        self.assertTrue(isinstance(utility, StorageServiceRoot))


class TestStorageServiceRootAbsoluteURL(TestCase):

    layer = FunctionalLayer

    def test_str(self):
        configuration = getUtility(IStorageConfiguration)
        request = configuration.createRequest("", {"HTTP_HOST": "localhost"})

        context = getUtility(IStorageRootPage)
        url = absoluteURL(context, request)
        self.assertEquals(url, "http://localhost/+download/")


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
