# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

import sys

from os import environ

from lpresults.tracker import defaults
from lpresults.tracker.services.config import Config
from lpresults.tracker.services.settings import Settings


module = sys.modules[__name__]
settings = Settings(defaults, module=module)

# Update settings from configuration
config_filename = environ.get("LPRESULTS_TRACKER_SETTINGS")
if config_filename:
    config = Config().read_filename(config_filename)
    settings.configure(config)

# Update settings from environment
settings.update(environ)

# Set environment with Django settings
environ["DJANGO_SETTINGS_MODULE"] = __name__

# Set modules dictionary with settings
names = __name__.split(".")
for index in xrange(len(names), 0, -1):
    name = ".".join(names[index - 1:])
    sys.modules[name] = settings
