# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

import unittest

from storm.zope.interfaces import IZStorm

from zope.component import queryUtility

from lpresults.tracker.testing.layers import DatabaseLayer


class DatabaseLayerTest(unittest.TestCase):

    layer = DatabaseLayer

    def setUp(self):
        self.zstorm = queryUtility(IZStorm)

    def test_zstormUtility(self):
        self.assertTrue(self.zstorm)

    def test_trackerStore(self):
        self.assertTrue(self.zstorm.get("tracker"))

    def test_testStore(self):
        self.assertTrue(self.zstorm.get("test-1"))

    def test_testDatabaseAvailable(self):
        test = self.zstorm.get("test-1")
        result = test.execute("SELECT * FROM patch WHERE 1=2").get_all()
        self.assertEquals(len(result), 0)


def test_suite():
    return unittest.defaultTestLoader.loadTestsFromName(__name__)


if __name__ == "__main__":
    unittest.main(defaultTest="test_suite")
