# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

"""Validator functions."""

__metaclass__ = type

__all__ = [
    "attachment_size_validator",
    ]

from zope.schema.interfaces import ValidationError


VALID_ATTACHMENT_SIZE = 2097152


def attachment_size_validator(data):
    """Return True if the attachment size is valid,
       or raise a ValidationError.

    :param data: The attachment data.
    """
    size = len(data)
    if size == 0:
        raise ValidationError(u"Cannot upload empty file.")

    elif size > VALID_ATTACHMENT_SIZE:
        raise ValidationError(
            u"Cannot upload files larger than %i bytes"
            % VALID_ATTACHMENT_SIZE)

    else:
        return True
