# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "apidoc",
    ]

import os

from django.shortcuts import render_to_response
from django.template.context import RequestContext

from zope.component import getUtility
from zope.traversing.browser import absoluteURL

from lazr.restful.interfaces import (
    IServiceRootResource,
    IWebServiceConfiguration,
    )


def apidoc(request, path):
    dictionary = {}

    if not path:
        path = "index.html"

    elif path != "index.html":
        configuration = getUtility(IWebServiceConfiguration)
        service_context = getUtility(IServiceRootResource)
        service_request = configuration.createRequest("", request.environ)
        service_request.annotations[service_request.VERSION_ANNOTATION] = (
            os.path.splitext(path)[0])

        dictionary["LAUNCHPAD_RESULTS_SERVICE_ROOT"] = absoluteURL(
            service_context, service_request).strip("/")

    template_name = os.path.join("apidoc", path)
    return render_to_response(
        template_name, dictionary, context_instance=RequestContext(request))
