# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "gm",
    ]

from django.shortcuts import render_to_response
from django.template.context import RequestContext

from zope.component import getUtility
from zope.traversing.browser import absoluteURL

from lazr.restful.interfaces import (
    IServiceRootResource,
    IWebServiceConfiguration,
    )

from lpresults.tracker import settings


def gm(request, path):
    configuration = getUtility(IWebServiceConfiguration)
    service_context = getUtility(IServiceRootResource)
    service_request = configuration.createRequest("", request.environ)
    service_request.annotations[service_request.VERSION_ANNOTATION] = (
        configuration.active_versions[-1])

    launchpad_results_service_root = absoluteURL(
        service_context, service_request)
    launchpad_results_web_root = request.build_absolute_uri("/")
    launchpad_web_all = settings.LAUNCHPAD_WEB_ROOT.replace("://", "://*.")

    return render_to_response("gm/%s" % path, {
            "LAUNCHPAD_RESULTS_SERVICE_ROOT": launchpad_results_service_root,
            "LAUNCHPAD_RESULTS_WEB_ROOT": launchpad_results_web_root,
            "LAUNCHPAD_WEB_ALL": launchpad_web_all,
        },
        context_instance=RequestContext(request),
        mimetype="text/javascript; charset=utf-8")
