# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

"""Pillar related views."""

__metaclass__ = type

__all__ = [
    "pillar",
    ]

from django.http import HttpResponseNotFound
from django.shortcuts import render_to_response
from django.template import RequestContext

from zope.component import getUtility

from lpresults.tracker.interfaces.testpillar import ITestPillarSet


def pillar(request, pillar_name):
    pillar = getUtility(ITestPillarSet).getByName(pillar_name)
    if pillar is None:
        return HttpResponseNotFound("Invalid pillar name: %s" % pillar_name)

    dictionary = {
        "pillar": pillar,
        }

    return render_to_response(
        "pillar/index.html",
        dictionary,
        RequestContext(request))
