# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "root",
    ]

from django.shortcuts import render_to_response
from django.template.context import RequestContext

from zope.component import getUtility
from zope.traversing.browser import absoluteURL

from lazr.restful.interfaces import (
    IServiceRootResource,
    IWebServiceConfiguration,
    )


def root(request):
    configuration = getUtility(IWebServiceConfiguration)
    service_context = getUtility(IServiceRootResource)
    service_request = configuration.createRequest("", request.environ)
    service_request.annotations[service_request.VERSION_ANNOTATION] = (
        configuration.active_versions[-1])

    launchpad_results_api_root = absoluteURL(
        service_context, service_request)[:-5]

    return render_to_response(
        "root.html",
        dictionary={
            "LAUNCHPAD_RESULTS_API_ROOT": launchpad_results_api_root,
            },
        context_instance=RequestContext(request))
