# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "Functor",
    ]


class Functor:

    def __init__(self, function, *args, **kwargs):
        assert callable(function), "function should be a callable obj"
        self._function = function
        self._args = args
        self._kwargs = kwargs

    def __call__(self, *args, **kwargs):
        """call function"""
        _args = list(self._args)
        _args.extend(args)
        _kwargs = self._kwargs.copy()
        _kwargs.update(kwargs)
        return apply(self._function, _args, _kwargs)
