# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "DmesgParser",
    ]

from re import compile
from string import hexdigits


ADDRESS_RE = compile(r"^.*eth.*(?P<address>([%(hex)s]{2}:){5}[%(hex)s]{2})"
    % {"hex": hexdigits})


class DmesgParser:

    def __init__(self, stream):
        self.stream = stream

    def run(self, result):
        for line in self.stream:
            match = ADDRESS_RE.match(line)
            if match:
                address = match.group("address")
                result.addAddress(address)
