# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from cStringIO import StringIO

from unittest import (
    defaultTestLoader,
    TestCase,
    )

from lpresults.xunit.parsers.dmisys import DmiSysParser
from lpresults.xunit.parsers.tests.test_dmi import TestDmiMixin


FAKE_DMI_SYS = """\
/sys/class/dmi/id/bios_vendor:BIOS VENDOR
/sys/class/dmi/id/bios_version:BIOS PRODUCT
/sys/class/dmi/id/sys_vendor:SYSTEM VENDOR
/sys/class/dmi/id/product_name:SYSTEM PRODUCT
/sys/class/dmi/id/product_serial:SYSTEM SERIAL
/sys/class/dmi/id/board_vendor:Not Available
/sys/class/dmi/id/board_name:Not Available
/sys/class/dmi/id/board_serial:Not Available
/sys/class/dmi/id/chassis_vendor:CHASSIS VENDOR
/sys/class/dmi/id/chassis_type:10
/sys/class/dmi/id/chassis_serial:Not Available
"""


class TestDmiSys(TestCase, TestDmiMixin):

    def getParser(self):
        stream = StringIO(FAKE_DMI_SYS)
        return DmiSysParser(stream)


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
