# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from unittest import defaultTestLoader

from lpresults.xunit.application import ApplicationRunner
from lpresults.xunit.testing.cases import ApplicationTestCase
from lpresults.xunit.testing.fakes import FakeApplication


class TestApplicationRunner(ApplicationTestCase):

    def setUp(self):
        super(TestApplicationRunner, self).setUp()
        self.manager = ApplicationRunner(application_factory=FakeApplication)

    def test_getParser(self):
        parser = self.manager.getParser()
        self.assertEquals(len(parser.option_groups), 2)
        self.assertEquals(parser.option_groups[0].title, "Launchpad options")
        self.assertEquals(parser.option_groups[1].title, "Logging options")

    def test_parseArgsInvalid(self):
        self.assertRaises(SystemExit,
            self.manager.parseArgs,
            ["--foo-bar"])

    def test_createApplication(self):
        application = self.manager.createApplication(["foo"])
        self.assertTrue(isinstance(application, FakeApplication))


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
