# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from cStringIO import StringIO

from unittest import (
    defaultTestLoader,
    TestCase,
    )

from lpresults.xunit.logger import get_logger


class TestGetLogger(TestCase):

    def runLogger(self, log_level):
        log_stream = StringIO()
        logger = get_logger(log_level, log_stream=log_stream)
        logger.error("This is an error")
        logger.warn("This is a warning")
        logger.info("This is info")
        logger.debug("This is debug")
        log_stream.seek(0)
        return log_stream

    def test_error(self):
        log_stream = self.runLogger("ERROR")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")

    def test_warning(self):
        log_stream = self.runLogger("WARNING")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertTrue("This is a warning" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")

    def test_info(self):
        log_stream = self.runLogger("INFO")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertTrue("This is a warning" in log_stream.readline())
        self.assertTrue("This is info" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")

    def test_debug(self):
        log_stream = self.runLogger("DEBUG")
        self.assertTrue("This is an error" in log_stream.readline())
        self.assertTrue("This is a warning" in log_stream.readline())
        self.assertTrue("This is info" in log_stream.readline())
        self.assertTrue("This is debug" in log_stream.readline())
        self.assertEquals(log_stream.readline(), "")


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
